# MAIN IMPORTS =============================================================================================================================================== #
import psyco
psyco.full()
import es
import keyvalues
import playerlib
import popuplib
import langlib
# ============================================================================================================================================================ #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

temp = {'toggle':'yes'}

# ============================================================================================================================================================ #
# ========================================================================= UNLOAD =========================================================================== #
# ============================================================================================================================================================ #
def unload():
	### Popups ###
	func.popupDelete('manager')
	func.popupDelete('manager_getTarget')
	func.popupDelete('manager_edit')
	func.popupDelete('manager_getGroup')
	
# ============================================================================================================================================================ #
# ======================================================================= MAIN BLOCKS ======================================================================== #
# ============================================================================================================================================================ #
def modulePopup(userid):
	func.popupDelete('manager')
	popup = popuplib.create('manager')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar(func.version)))
	popup.addline('\n \n :: %s' % func.lang_titles('manager_name'))
	popup.addline(func.pline)
	popup.addline('->1. %s' % func.lang_admins('add'))
	popup.addline('->2. %s' % func.lang_admins('remove'))
	popup.addline('->3. %s' % func.lang_admins('edit_admin'))
	popup.addline(' ')
	popup.addline(' :: Groups')
	popup.addline(func.pline)
	popup.addline('->4. %s' % func.lang_groups('create_group'))
	popup.addline('->5. %s' % func.lang_groups('delete_group'))
	popup.addline('->6. %s' % func.lang_groups('edit_group'))
	popup.addline(' ')
	popup.addline(func.pline)
	popup.addline('->8. %s' % func.lang_word('back'))
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.submenu(8, 'mainPage')
	popup.menuselect = managerChoice
	if int(es.ServerVar('sam_first_admin')) == 0: popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------ #
def managerChoice(userid, choice, popup):
	func.popupDelete('manager_getTarget')
	if choice in range(1,4):
		if choice == 1:   popup = popuplib.easymenu('manager_getTarget', None, addChoice)
		elif choice == 2: popup = popuplib.easymenu('manager_getTarget', None, remChoice)
		elif choice == 3: popup = popuplib.easymenu('manager_getTarget', None, editChoice)
		choices = {1:'add',2:'remove',3:'edit'}
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('manager_name')))
		popup.setdescription('\n # %s' % func.lang_titles('manager_%s_admin_desc' % choices[choice]))
		if choice == 1:
			for player in playerlib.getPlayerList('#human'): popup.addoption(player, player.name)
		elif choice > 1:
			for admin in keyvalues.getKeyGroup(admins.db): popup.addoption(admin, es.keygetvalue(admins.db, admin, 'name'))
		popup.submenu(10, 'manager')
		popup.send(userid)
	elif choice in range(4,7):
		groups = es.import_addon('sam/admins/groups')
		if choice == 4: groups.startFilter(userid)
		if choice in [5,6]:
			if groups.checkDB() and es.exists('keygroup', groups.db):
				if len(list(keyvalues.getKeyGroup(groups.db))) > 0: groups.chooseGroup(userid, choice)
				else:
					func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
					modulePopup(userid)
			else:
				func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
				modulePopup(userid)
	elif choice < 8: modulePopup(userid)

# ============================================================================================================================================================ #
# ======================================================================== FUNCTIONS ========================================================================= #
# ============================================================================================================================================================ #
def addChoice(userid, choice, popup):
	target = playerlib.getPlayer(choice)
	if not admins.isAdmin(target.steamid):
		admins.add(target.steamid)
		admins.update(target)
		editChoice(userid, target.steamid, popup)
		func.hudhint(userid, func.lang_admins('admin_added', {'target':target.name}), func.admins_hudtag)
	else:
		func.hudhint(userid, func.lang_admins('is_admin', {'admin':target.name}), func.admins_hudtag)
		modulePopup(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def remChoice(userid, choice, popup):
	#if admins.isAdmin(choice):
	admin = admins.getAdmin(choice)
	func.hudhint(userid, func.lang_admins('admin_removed', {'target':admin['name']}), func.admins_hudtag)
	admins.remove(userid, choice)
	#else: func.tell(userid, func.lang_admins('not_an_admin'), func.adminstag)
	modulePopup(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def editChoice(userid, choice, popup, page = None):
	if not str(choice).startswith('STEAM'): choice = es.getplayersteamid(choice)
	admin = admins.getAdmin(choice)
	es.set('sam_%s_setimmunity' % userid, 0)
	es.set('sam_%s_setgroup' % userid, 0)
	if admin:
		func.popupDelete('manager_edit')
		popup = popuplib.easymenu('manager_edit', None, editAdmin_Choice)
		popup.c_beginsep = func.pline + '\n# %s: %s\n# ID: %s\n ' % (func.lang_word('name'),admin['name'], choice)
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_admins('edit_admin')))
		popup.addoption({'item':'toggle','admin':admin}, func.lang_admins('toggle_all', {'state':func.lang_word(temp['toggle'])}))
		popup.addoption({'item':'group','admin':admin}, '%s: %s' % (func.lang_word('group'), admin['group']))
		popup.addoption({'item':'immunity','admin':admin}, '%s: %s' % (func.lang_word('immunity'), admin['immunity']))
		for item in admins.access: popup.addoption({'item':item,'admin':admin}, '%s: %s' % (item, func.lang_word(admin[item])))
		popup.submenu(10, 'manager')
		if page != None: popup.sendPage(userid, page)
		else: popup.send(userid)
	else:
		func.tell(userid, func.lang_admins('not_an_admin'))
		modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------ #
def editAdmin_Choice(userid, choice, popup):
	admin = choice['admin']
	data  = admins.access
	if choice['item'] not in ('toggle','immunity','group'): page = func.getPage(data.index(choice['item']) + 3, 7)
	else: page = 1
	im = es.ServerVar('sam_%s_setimmunity' % (userid))
	if int(im) == 0:
		if choice['item'] == 'toggle':
			for item in data: es.keysetvalue(admins.db, admin['steamid'], item, temp['toggle'])
			es.keygroupsave(admins.db, 'sam/databases')
			if temp['toggle'] == 'yes': temp['toggle'] = 'no'
			else: temp['toggle'] = 'yes'
			editChoice(userid, admin['steamid'], popup, page)
		elif choice['item'] == 'immunity':
			im.set(1)
			temp[userid] = admin['steamid']
			es.addons.registerSayFilter(setFilter)
			func.tell(userid, func.lang_admins('immunity_get_value'), func.adminstag)
		elif choice['item'] == 'group':
			groups = es.import_addon('sam/admins/groups')
			if groups.checkDB() and es.exists('keygroup', groups.db):
				kg = keyvalues.getKeyGroup(groups.db)
				if len(list(kg)) > 0:
					func.popupDelete('manager_getGroup')
					popup = popuplib.easymenu('manager_getGroup', None, setAdminGroup)
					popup.c_beginsep = func.pline
					popup.c_pagesep  = func.pline
					popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('manager_groups_name')))
					popup.setdescription('\n# %s' % func.lang_titles('manager_groups_desc'))
					if not admin['group'] == 'None': popup.addoption({'admin':admin,'group':'None'}, func.lang_groups('remove_admin_group'))
					for item in kg: popup.addoption({'admin':admin,'group':item}, es.keygetvalue('sam_groups', item, 'name'))
					popup.submenu(10, 'manager')
					popup.send(userid)
				else:
					func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
					editChoice(userid, admin['steamid'], None)
			else:
				func.hudhint(userid, func.lang_groups('theres_no_groups'), func.admins_hudtag)
				editChoice(userid, admin['steamid'], None)
		else:
			if es.keygetvalue(admins.db, admin['steamid'], choice['item']) == 'yes': es.keysetvalue(admins.db, admin['steamid'], choice['item'], 'no')
			elif es.keygetvalue(admins.db, admin['steamid'], choice['item']) == 'no': es.keysetvalue(admins.db, admin['steamid'], choice['item'], 'yes')
			es.keygroupsave(admins.db, 'sam/databases')
			editChoice(userid, admin['steamid'], popup, page)

# ============================================================================================================================================================ #
# ========================================================================= EVENTS =========================================================================== #
# ============================================================================================================================================================ #
def setFilter(userid, text, teamonly):
	text.strip('"')
	im = es.ServerVar('sam_%s_setimmunity' % (userid))
	if int(im) == 1:
		target = temp[userid]
		if not text == '!cancel':
			try:
				if int(text.strip('"')) in range(0,101):
					im.set(0)
					es.addons.unregisterSayFilter(setFilter)
					es.keysetvalue(admins.db, target, 'immunity', int(text))
					es.keygroupsave(admins.db, 'sam/databases')
					editChoice(userid, target, None)
				else: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
			except: func.tell(userid, func.lang_admins('immunity_wrong_range'), func.adminstag)
		else:
			es.addons.unregisterSayFilter(setFilter)
			editChoice(userid, target, None)
			im.set(0)
			func.hudhint(userid, func.lang_base('op_canceled'), func.server_hudtag)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================ #
# ========================================================================= BLOCKS =========================================================================== #
# ============================================================================================================================================================ #
def setIM(): es.addons.registerSayFilter(setFilter)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def setAdminGroup(userid, choice, popup):
	admin = choice['admin']
	es.keysetvalue(admins.db, admin['steamid'], 'group', choice['group'])
	es.keygroupsave(admins.db, 'sam/databases')
	editChoice(userid, admin['steamid'], None)
	if choice['group'] == 'None': func.hudhint(userid, func.lang_groups('removed_admin_group', {'admin':admin['name'],'group':admin['group']}), func.admins_hudtag)
	else: func.hudhint(userid, func.lang_admins('added_group', {'admin':admin['name'],'group':choice['group']}), func.admins_hudtag)

# ============================================================================================================================================================ #