# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import cmdlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
jetpacktag     = '#greenJETPACK'
jetpack_hudtag = 'JETPACK'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_jetpack_%s' % ply.steamid)
		var.set(0)

	cmdlib.registerSayCommand('!jetpack', jetpackCMD,'SAM')
	cmdlib.registerSayCommand('!sam_jetpack', jetpackCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_jetpack_%s' % ply.steamid)) == 1: take(ply)

	cmdlib.unregisterSayCommand('!jetpack')
	cmdlib.unregisterSayCommand('!sam_jetpack')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def jetpackCMD(userid, args):
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Jetpack'):
			if args:
				try:
					target = playerlib.getPlayer(es.getuserid(args[0]))
					if admins.checkImmunity(es.getplayersteamid(userid), target.steamid): moduleAction(userid, target, 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), jetpack_hudtag)
			else: block.function(userid, 'Jetpack', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target, cmd=0):
	targetvar = es.ServerVar('sam_jetpack_%s' % target.steamid)
	if int(targetvar) == 0: give(target)
	else: take(target)
	if cmd == 0: block.function(userid, 'Jetpack', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def give(target):
	targetvar = es.ServerVar('sam_jetpack_%s' % target.steamid)
	targetvar.set(1)
	target.jetpack(1)
	func.tell('#all', func.lang_pcontrol('jetpack_target_give', {'target':target.name}), jetpacktag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def take(target):
	targetvar = es.ServerVar('sam_jetpack_%s' % target.steamid)
	targetvar.set(0)
	target.jetpack(0)
	func.tell('#all', func.lang_pcontrol('jetpack_target_take', {'target':target.name}), jetpacktag)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_jetpack_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_spawn(ev):
	if int(es.ServerVar('sam_jetpack_%s' % ev['es_steamid'])) == 1: take(playerlib.getPlayer(ev['userid']))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_jetpack_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================== #